{***************************************************************************}
{                              UNIDAD DE RELOJ

                                 Copyright (c) 1998 Marco Antonio Alvarado
}
{***************************************************************************}

UNIT UReloj;

INTERFACE

  VAR
    TicsFaltan : Word;

  PROCEDURE RestaTics (Cantidad : Word);
  PROCEDURE EsperaTicsFaltan;

IMPLEMENTATION

  USES
    UDS;  {Unidad de DOS Services}

  VAR
    ViejoExitProc,
    ViejaAtiende : Pointer;

{$F+}
  PROCEDURE Atiende; INTERRUPT;
{$F-}
  BEGIN
    IF TicsFaltan > 0 THEN Dec (TicsFaltan);

    ASM
      PUSHF
      CALL ViejaAtiende
    END;

  END;

  PROCEDURE RestaTics (Cantidad : Word);
  BEGIN
    TicsFaltan := Cantidad;
  END;

  PROCEDURE EsperaTicsFaltan;
  BEGIN
    WHILE TicsFaltan > 0 DO;
  END;

{$F+}
  PROCEDURE Sale;
{$F-}
  BEGIN
    ExitProc := ViejoExitProc;
    PoneInterrupcion ($1c, ViejaAtiende);
  END;

BEGIN
  TicsFaltan := 0;
  ViejaAtiende := TomaInterrupcion ($1c);
  PoneInterrupcion ($1c, @Atiende);
  ViejoExitProc := ExitProc;
  ExitProc := @Sale;
END.